     LIST P=16F628a
     #include "P16f628a.INC"
     __CONFIG 3F29H

     ;     PIC16F628A
     ; :   .
     ;  .
     ; valera-53@mail.ru

TMP   EQU     20h         ;  .
SIM   EQU     21h         ;   .
CUR   EQU     22h         ;   .
CUR1  EQU     23h         ;   .
buf0  EQU     28h         ;
buf1  EQU     29h         ; 
buf2  EQU     2Ah         ; .
buf3  EQU     2Bh         ;
buf4  EQU     2Ch         ;
buf5  EQU     2Dh         ;
      clrf  TMP           ;
      call  CR            ;
      goto M8             ;
L0:   BTFSC PORTA,2       ;  
      call SCH            ;
      BTFSC PORTA,0       ;
      goto   C0           ; 
      BTFSC PORTA,1       ;
      goto   C3           ;
      goto   L0           ;
M1:   bcf    PORTA,3      ; .  .
      bcf    PORTA,4      ;
      movlw  B'00000001'  ;
      movwf  PORTB        ;
      bsf    PORTA,4      ;
      call   DEL          ;
      bcf    PORTA,4      ;
      call   DEL          ;
      return              ;
M3:   bsf    PORTA,3      ;  .  
      movf   SIM,0        ;
      movwf  PORTB        ;
      bsf    PORTA,3      ;
      bsf    PORTA,4      ;
      call   DEL          ;
      bcf    PORTA,4      ;
      call   DEL          ;
      bcf    PORTA,3      ;
      call   DEL          ;
      return              ;
M5:   bcf    PORTA,3      ; .    B
      bcf    PORTA,4      ;  .
      movf   CUR,0        ;
      movwf  PORTB        ;
      bsf    PORTA,4      ;
      call   DEL          ;
      bcf    PORTA,3      ;
      bcf    PORTA,4      ;
      call   DEL          ;
      return              ;
M4:   bcf    PORTA,3      ; .    B
      bcf    PORTA,4      ;  .
      movf   CUR1,0       ;
      movwf  PORTB        ;
      bsf    PORTA,4      ;
      call   DEL          ;
      bcf    PORTA,4      ;
      call   DEL          ;
      return              ;
M8:    bcf STATUS,RP1     ; 0
       bcf STATUS,RP0     ;
       clrf PORTA         ; 
       movlw 0x07         ;  /
       movwf CMCON        ; 
       bcf STATUS,RP1     ; 1
       bsf STATUS,RP0     ;
       movlw 0x07         ;   
       movwf TRISA        ;  
       bcf STATUS,RP0     ;  0
       call M9            ;
       clrf PORTB         ;   
       bsf STATUS,RP0     ;   1
      movlw 0x00          ;    
      movwf TRISB         ; 
      bcf STATUS,RP0      ;
      call M9             ;
      bcf PORTA,3         ;  .  .
      bcf PORTA,4         ;
      movlw  B'00001100'  ;  - 1   
      movwf  PORTB        ;
      bsf PORTA,4         ;
      call   DEL          ;
      bcf PORTA,4         ;
      call   M9           ;
      bcf PORTA,3         ;
      bcf PORTA,4         ; ; .  .
      movlw  B'00111100'  ;
      movwf  PORTB        ;
      bsf PORTA,4         ;
      call   DEL          ;
      bcf PORTA,4         ;
      call   M9           ;
      movlw  84h          ;
      movwf  CUR          ;
      movlw  0C4h         ;
      movwf  CUR1         ;
      call   IND          ;
      call   M4           ;
      call   M9           ;
      movlw  56h          ;
      movwf  SIM          ;
      call   M3           ;
      call   M7           ;
      movlw  45h          ;
      movwf  SIM          ;
      call   M3           ;
      call   M7           ;
      movlw  52h          ;
      movwf  SIM          ;
      call   M3           ;
      call   M7           ;
      movlw  2Dh          ;
      movwf  SIM          ;
      call   M3           ;
      call   M7           ;
      movlw  31h          ;
      movwf  SIM          ;
      call   M3           ;
      call   M7           ;
      movlw  30h          ;
      movwf  SIM          ;
      call   M3           ;
      call   M7           ;
      goto   L0           ;
IND:  call M5             ; .   
      call M9             ;
      movf buf5,0         ;
      addlw 30h           ;
      movwf  SIM          ;
      call M3             ;
      call M7             ;
      movf buf4,0         ;
      addlw 30h           ;
      movwf  SIM          ;
      call M3             ;
      call M7             ;
      movf buf3,0         ;
      addlw 30h           ;
      movwf  SIM          ;
      call M3             ;
      call M7             ;
      movf buf2,0         ;
      addlw 30h           ;
      movwf  SIM          ;
      call M3             ;
      call M7             ;
      movf buf1,0         ;
      addlw 30h           ;
      movwf  SIM          ;
      call M3             ;
      call M7             ;
      movf buf0,0         ;
      addlw 30h           ;
      movwf  SIM          ;
      call M3             ;
      call M7             ;
      return              ;
C0:   BTFSC PORTA,1       ;   
      goto C1             ;  "+"
      goto C0             ;
C1:   BTFSS PORTA,0       ;
      goto C2             ;
      goto C1             ;
C2:   BTFSC PORTA,1       ;
      goto C2             ;
      goto S0             ;
L1:   goto L0             ;
C3:   BTFSC PORTA,0       ;   
      goto C4             ;  "-"
      goto C3             ;
C4:   BTFSS PORTA,1       ;
      goto C5             ;
      goto C4             ;
C5:   BTFSC PORTA,0       ;
      goto C5             ;
      goto S0             ;
      goto L0             ;
S0:   incf  buf0,1        ;
      movf  buf0,0        ;   
      bcf   STATUS,Z      ;
      xorlw 0Ah           ;
      BTFSC STATUS,Z      ;
      goto  M51           ;
      goto L1             ;
M51:  clrf buf0           ;
      goto S1             ;
      goto L1             ;              ;
S1:   incf  buf1,1        ;
      movf  buf1,0        ;   
      bcf   STATUS,Z      ;
      xorlw 0Ah           ;
      BTFSC STATUS,Z      ;
      goto  M52           ;
      goto L1             ;
M52:  clrf buf1           ;
      call S2             ;
      goto L1             ;
S2:   incf  buf2,1        ;
      movf  buf2,0        ;   
      bcf   STATUS,Z      ;
      xorlw 0Ah           ;
      BTFSC STATUS,Z      ;
      CALL  M53           ;
      RETURN              ;
M53:  clrf buf2           ;
      call S3             ;
      RETURN              ;
S3:   incf  buf3,1        ;
      movf  buf3,0        ;   
      bcf   STATUS,Z      ;
      xorlw 0Ah           ;
      BTFSC STATUS,Z      ;
      CALL  M54           ;
      RETURN              ;
M54:  clrf buf3           ;
      call S4             ;
      RETURN              ;
S4:   incf  buf4,1        ;
      movf  buf4,0        ;   
      bcf   STATUS,Z      ;
      xorlw 0Ah           ;
      BTFSC STATUS,Z      ;
      CALL  M55           ;
      RETURN              ;
M55:  clrf buf4           ;
      call S5             ;
      RETURN              ;
S5:   incf  buf5,1        ;
      movf  buf5,0        ;   
      bcf   STATUS,Z      ;
      xorlw 0Ah           ;
      BTFSC STATUS,Z      ;
      call  M56           ;
      RETURN              ;
M56:  clrf buf5           ;
      RETURN              ;
CR:   clrf  buf0          ;
      clrf  buf1          ;
      clrf  buf2          ;
      clrf  buf3          ;
      clrf  buf4          ;
      clrf  buf5          ;
      return              ;
SCH:  BTFSC PORTA,2       ;
      goto SCH            ;
      call IND            ;
      call CR             ;
      return              ;
M9:   movlw  46h          ; 
      movwf  TMP          ; 
F0:   decfsz TMP,1        ;  
      goto   F0           ;
      return              ;
M7:   movlw  32h          ; 
      movwf  TMP          ; 
F1:   decfsz TMP,1        ;  
      goto   F1           ;
      return              ;
DEL:  nop                 ;
      nop                 ;  
      nop                 ;
      nop                 ;
      nop                 ;
      return              ;
      end                 ;  













                 